#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sumread.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# 06Mar07 BB      - Changed refresh time from 36000 to 36000 
# 08Jan08 BB 2.01 - Added logToFile logic 
# =========================================================
$version = "2.01"; 

$debug = 1;
$| = 1;
$log = "/opt/dbamon/log/dbamon_ora_sumread.log";

$P = "dbamon_ora_sumread.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";

$mode = uc $ARGV[0];
$modelc = lc $ARGV[0];

#$rowcolor = "b0e0e6";
$rowcolor = "dcdcdc";

$starcolor = "green"; 

$table_width = "750";

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
#$arg5 = $ARGV[5];
#$arg6 = $ARGV[6];
#$arg7 = $ARGV[7];
#$arg8 = $ARGV[8];

$g_stime = time;

if ($mode ne "TEST" && $mode ne "PROD")
{
  print "$P | Usage: $0 {TEST | PROD}\n";
  exit 1;
}

#------------------------------------------------------------------------------
sub logToFile
#------------------------------------------------------------------------------
{
  $logfile = "/opt/dbamon/dat/history/health_$modelc.txt"; 
  chop($logdate = `date +%Y/%m/%d-%H`);
  &msg("logToFile() Logging to $logfile - logdate=$logdate"); 

  if (system("grep '^$logdate' $logfile 2>&1") == 0)
  {
    &msg("  An entry for logdate=$logdate has already been creating - returning"); 
  }
  else
  {
    &msg("  Creating entry for logdate=$logdate"); 
    open(LOGFILE, ">>$logfile") || &error("Cannot open output $logfile - $!");
    print LOGFILE "$logdate  Health: $health_save  InstanceCount: $health_tot\n"; 
    close(LOGFILE); 
    &msg("Last 3 lines of $logfile");
    system("tail -3 $logfile"); 
  }

  &msg("logToFile() Done"); 
}

#------------------------------------------------------------------------------
sub healthcolors
#------------------------------------------------------------------------------
{
  if    ($health >= 90) { $healthcolor = "#00ff00"; }
  elsif ($health >= 80) { $healthcolor = "#99cc00"; }
  elsif ($health >= 70) { $healthcolor = "#ffff00"; }
  elsif ($health >= 60) { $healthcolor = "#ff9900"; }
  else                  { $healthcolor = "#ff0000"; }
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = $_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
  system("echo '$date ${P} | $msgmsg' >> $log");
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=$rowcolor"; 
  }
}

#------------------------------------------------------------------------------
sub bg2
#------------------------------------------------------------------------------
{
  if ($lastbg2 == 1)
  {
    $lastbg2 = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg2 = 1;
    return "bgcolor=$rowcolor"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  ($errmsg,$errorrc,$nomail) = @_;

  ($er_package, $er_filename, $er_line) = caller;
  $callermsg = "Calling er_package=$er_package er_filename=$er_filename er_line=$er_line"; 
  
  &msg("=============================================================");
  &msg("Fatal Error: $errmsg");
  &msg("Caller Info: $callermsg");
  &msg("SQL Error:   $DBI::errstr");  
  &msg("=============================================================");
  &msg("Exiting rc=1");
  $e_time = time - $g_stime;

  system("echo '$callermsg e_time=$e_time $DBI::errstr' | mailx -m -s '$P - $errmsg [AUTO]' border\@dba.it.thecompany.com") unless $nomail;

  if ($errorrc eq "") { exit 1; }
  else                { exit $errorrc; }
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ENV{'ORACLE_SID'};

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) || &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 10000;
}

#-----------------------------------------------------------------------------
sub makeTitle
#-----------------------------------------------------------------------------
{
  &msg("Creating title section");

  print HTML "<title>DBAmon Instance Summary - Mode: $mode</title>\n" ;
  print HTML "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTML "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTML "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTML "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary</center>\n";
  print HTML "</table>\n" ;

  print HTML "$links";

  print HTML "<hr>\n" ;
}

#-----------------------------------------------------------------------------
sub hourGraph
#-----------------------------------------------------------------------------
{
#  print HTML "
#  <script language='JavaScript'>
#  var is_major = parseInt(navigator.appVersion);
#  var agt      = navigator.userAgent;
#  if (agt.indexOf('IE') == -1)
#  {
#    document.writeln(\"<h2><font color=red>DBAmon WWW Pages Only Look Correct If You Are Using IE</font></h3>  \" );
#  }
#  </script>
#";

  $statement  = "
    select
      to_char(ts, 'YYYY/MM/DD-HH24'),
      sev,
      count(*)
    from
      dbamon.event_history
    where
      ts >= sysdate - 1
      and dbamonmode like 'prod%'
    group by
      to_char(ts, 'YYYY/MM/DD-HH24'),
      sev
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $ts_x = -1;

  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $sev = $Data[1];
    $cnt = $Data[2];
    ## &msg("ts=$ts sev=$sev cnt=$cnt");

    $ts_x ++;
    push(@ts_list,$ts);
    push(@cn_list,$cnt);

    $total_cnt += $cnt;

    $max_cnt = $cnt if $cnt > $max_cnt;

    $this_dt = (split("-",$ts)) [0];
    $lo_date = $this_dt if $lo_date eq "";
    $hi_date = $this_dt;
  }

  print HTML "<table width=$table_width> \n" ;
  print HTML "<tr bgcolor=slate><th colspan=25><h5>Recent Ticket (Non-Duplicate 'prod' Critical Event) Count - Last 24 Hours\n";
  print HTML "<tr bgcolor=slate><th><h6>By Hour<br>(Date: ${lo_date}-${hi_date})\n" ;

  foreach $ts (@ts_list) 
  { 
    $this_ti = (split("-",$ts)) [1];
    print HTML "<th bgcolor=slate><h6>$this_ti\n"; 
  }
  
  print HTML "<tr><th bgcolor=slate><h6>Event Count\n";

  if    ($max_cnt > 200) { $z_factor = 0.25; }
  elsif ($max_cnt > 100) { $z_factor = 0.5; }
  elsif ($max_cnt > 20)  { $z_factor = 1; }
  else                   { $z_factor = 3; }
  
  #foreach $cn (@cn_list) 
  for ($i = 0; $i <= $ts_x; $i++)
  { 
    $this_cn = $cn_list[$i];
    $z = $this_cn * $z_factor;

    if    ($this_cn >= 30) { $color="red"; }
    elsif ($this_cn >= 20) { $color="yellow"; }
    else                   { $color="green"; }

    $dt = $ts_list[$i];

    print HTML "<td align=center valign=bottom><a href='/cgi-bin/dbamon_event_detail.pl?H,$dt'><img src='img/$color.gif' width=15 height=$z></a>\n"; 
  }

  print HTML "<tr bgcolor=slate><th><h6>(Last 24 Hours: $total_cnt)\n";

  foreach $cn (@cn_list) 
  { 
    print HTML "<td align=center><h6>$cn\n"; 
  }

  print HTML "</table><hr> \n" ;
}

#-----------------------------------------------------------------------------
sub dayGraph
#-----------------------------------------------------------------------------
{
  $ daygraph_days = 15;

  $statement  = "
    select
      to_char(ts, 'YYYY/MM/DD'),
      sev,
      count(*)
    from
      dbamon.event_history
    where
      ts >= sysdate - $daygraph_days
      and dbamonmode like 'prod%'
    group by
      to_char(ts, 'YYYY/MM/DD'),
      sev
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  undef @ts_list;
  undef @cn_list;

  $ts_x = -1;

  $max_cnt = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $sev = $Data[1];
    $cnt = $Data[2];
    ## &msg("ts=$ts sev=$sev cnt=$cnt");

    $ts_x ++;
    push(@ts_list,$ts);
    push(@cn_list,$cnt);

    $total_cnt += $cnt;

    $max_cnt = $cnt if $cnt > $max_cnt;

    $this_dt = (split("-",$ts)) [0];
    $lo_date = $this_dt if $lo_date eq "";
    $hi_date = $this_dt;
  }

  print HTML "<table width=$table_width> \n" ;
  print HTML "<tr bgcolor=slate><th colspan=19><h5>Recent Ticket (Non-Duplicate 'prod' Critical Event) Count - Last $daygraph_days Days\n";
  print HTML "<tr bgcolor=slate><th><h6>By Date\n" ;

  foreach $ts (@ts_list) 
  { 
    #$this_ti = (split("/",$ts)) [1];
    $this_ti = substr($ts,5);
    print HTML "<th bgcolor=slate><h6>$this_ti\n"; 
  }
  
  print HTML "<tr><th bgcolor=slate><h6>Event Count\n";

  if    ($max_cnt > 1500) { $z_factor = 0.05; }
  elsif ($max_cnt > 1000) { $z_factor = 0.10; }
  elsif ($max_cnt > 250)  { $z_factor = 0.15; }
  else                    { $z_factor = 0.25; }

  print "max_cnt=$max_cnt z_factor=$z_factor\n";
  
  #foreach $cn (@cn_list) 
  for ($i = 0; $i <= $ts_x; $i++)
  { 
    $this_cn = $cn_list[$i];
    $z = int($this_cn * $z_factor);

    if    ($this_cn >= 20*24) { $color="red"; }
    elsif ($this_cn >= 10*24) { $color="yellow"; }
    else                      { $color="green"; }

    $dt = $ts_list[$i];

    print HTML "<td align=center valign=bottom><a href='/cgi-bin/dbamon_event_detail.pl?D,$dt'><img src='img/$color.gif' width=15 height=$z></a>\n"; 
  }

  print HTML "<tr bgcolor=slate><th><h6>(Last 10 Days: $total_cnt)\n";

  foreach $cn (@cn_list) 
  { 
    print HTML "<td align=center><h6>$cn\n"; 
  }

  print HTML "</table><hr> \n" ;
}

#-----------------------------------------------------------------------------
sub emailCopy
#-----------------------------------------------------------------------------
{
  &msg("Updating DBAMON.EMAIL table");

  $statement  = "
    delete from dbamon.email
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->do($statement) || &error('Failed_on_DB_prepare_in_chgEnt');

  $statement  = "
    insert into dbamon.email
      (dbamonmode,
       rmt_hostname,
       rmt_domain,
       rmt_title1,
       dbms,
       dbmsandver,
       id1,
       id2,
       id3,
       id4,
       id5,
       id6,
       id7,
       id8,
       id9,
       id10 )
    select 
       dbamonmode,
       rmt_hostname,
       rmt_domain,
       rmt_title1,
       dbms,
       dbmsandver,
       id1,
       id2,
       id3,
       id4,  
       id5,  
       id6,  
       id7,  
       id8,  
       id9,  
       id10  
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
      and dbms != '(ServerAlias)'
  ";
  ##print "$statement\n";
  $sth = $dbh->do($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
}

#-----------------------------------------------------------------------------
sub makeScoreboard
#-----------------------------------------------------------------------------
{
  &msg("Creating scoreboard section");

  # Count tasks
  $statement  = "
    select 
      count(distinct dbamonmode),
      avg(iter_dur)
    from 
      dbamon.task
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $task_count = $Data[0];
    $task_avgtm = int($Data[1] / 60);
  }

  $statement  = "
    select 
      count(distinct system)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 2)");

  while (@Data = $sth->fetchrow_array)
  {
    $server_count = $Data[0];
  }
  ##print "server_count=$server_count \n";

  # Get total space allocated

  $statement  = "
    select 
      sum(spacealloc) 
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 3)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $total_space = $Data[0];
  }

  $statement  = "
    select 
      count(*)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
      and dbms != '(ServerAlias)'
  ";
  print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 4)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $health_tot = $Data[0];
  }

  $statement  = "
    select 
      count(*)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
      and dbms != '(ServerAlias)'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 5)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $detail_tot = $Data[0];
  }

  ## $statement  = "select sum(count) from dbamon.summary_tot where text = 'No Events' and dbamonmode like '%${modelc}%'";
  ## ##print "$statement\n";
  ## $sth = $dbh->prepare($statement) || ##         &error('Failed_on_DB_prepare_in_chgEnt');
  ## $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  ## $selectcount = 0;
  ## while (@Data = $sth->fetchrow_array)
  ## {
  ##   $health_good = $Data[0];
  ## }
  ## if ($health_tot > 0) { $health = int(($health_good / $health_tot) * 100); }

  $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and health != -1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $health = int($Data[0]);
    $health = sprintf ("%.1f", $Data[0]);
    print "health=$health\n";
  }

  &healthcolors;
  &msg("DEBUG - health=$health"); 
  $health_save = $health;

  print HTML "<table width=$table_width>\n";
  print HTML "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Instance Scoreboard</center></font></b>\n";
  print HTML "</table>\n";

  print HTML "<table width=$table_width>\n";
  print HTML "<tr>
    <th bgcolor=slate colspan=4><h5>All Instance <a href='http://dbamon.com/misc/health.shtml'>Health Index</a> (0-100):
    <td bgcolor=$healthcolor width=20%><font face=$font size=6><center>
      <a href='/cgi-bin/dbamon_rpt.pl?$modelc,health'>$health</a>
      </center></font>\n";

  # 
  # Marquee
  # 

  $statement  = "select 
    title, 
    sev,
    count(*) 
  from 
    dbamon.event_history 
  where 
    ts >= sysdate - 10
    and dbamonmode like 'prod%'
  group by 
    title,
    sev 
  order by 
    3 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $worst_instances = "";
  while (@Data = $sth->fetchrow_array)
  {
    $instance = $Data[0];
    $sev      = $Data[1];
    $count    = $Data[2];
    last if ++$selectcount > 10;

    $worst_instances .= "$instance ($sev=$count) ... ";
  }

  print HTML "<tr><td bgcolor=slate align=center width=15%><h6>Current Status:\n";
  print HTML "<td colspan=3 bgcolor=darkblue align=center><h6><font color=wheat><!--#include virtual=\"/dbamon/status_$modelc.txt\"--></font>\n";
  print HTML "<td bgcolor=slate>\n";

  $marquee_msg  = "DBAmon is Monitoring $health_tot Instance(s) - On $server_count Server(s) - $total_space gB Total DB Space ... ";
  $marquee_msg .= "$task_count DBAmon Task(s) ... ";

  print HTML "<tr><td bgcolor=slate align=center><h6>Statistics:\n";
  print HTML "<td colspan=3><marquee bgcolor=darkblue scrolldelay=10 scrollamount=3><h6><font color=wheat>$marquee_msg</font></marquee>\n";
  print HTML "<td bgcolor=slate>\n";

  $marquee_msg = "$worst_instances ";
  print HTML "<tr><td bgcolor=slate align=center><h6>Worst Instances:\n";
  print HTML "<td colspan=3><marquee bgcolor=darkblue scrolldelay=250 scrollamount=3><h6><font color=pink>$marquee_msg</font></marquee>\n";
  print HTML "<td bgcolor=slate align=center nowrap><h6>(Last 10 Days 'prod')\n";

  print HTML "<tr><td colspan=5><p><hr>\n";


  
  # Graph of critical events during the last 24 hours
  &hourGraph;
  &dayGraph;

  #print HTML "</table>\n";
  #print HTML "<table width=50% border=0>\n";

  print HTML "<tr bgcolor=slate><th colspan=4><h5><a href='http://dbamon.com/misc/notify.shtml'>Event Severity</a><th><h5>Event Count\n";

  $statement  = "select text, color, sum(count) from dbamon.summary_tot where dbamonmode like '${modelc}%' and text like '%Event%' group by text, color order by 3 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $section_tot = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $text   = $Data[0];
    $color  = $Data[1];
    $count  = $Data[2];

    &msg("DEBUG - text=$text count=$count");

    $sev = "";
    $order = "";
    if    ($text =~ /^Critical/) { $sev = "C"; $order = 1; }
    elsif ($text =~ /^Warning/)  { $sev = "W"; $order = 2; }
    elsif ($text =~ /^Info/)     { $sev = "I"; $order = 3; }
    elsif ($text =~ /^User/)     { $sev = "U"; $order = 4; }
    elsif ($text =~ /^Security/) { $sev = "S"; $order = 5; }
    elsif ($text =~ /^Perf/)     { $sev = "P"; $order = 6; }
    elsif ($text =~ /^Notation/) { $sev = "N"; $order = 7; }
    else                         { next; }

    if ($sev ne "")
    {
      $event_type = "<a href='sev_${modelc}.html#${sev}'>$text</a>";
    }
    else
    {
      $event_type = $text;
    }

    # Make is more readable
    # $color = "lime" if $color =~ /green/;

    if ($color =~ /black/ || $color =~ /green/ || $color =~ /blue/ || $color =~ /gray/)
    {
      #print HTML "<tr $bg><td bgcolor=$color colspan=2><h5><font face=$font color=white>$event_type</font><td align=right><h5>$count \n";
      $order_hash{$order} = "<td bgcolor=$color colspan=4><h5><font face=$font color=white>$event_type</font><td align=right><h5>$count";
    }
    else
    {
      #print HTML "<tr $bg><td bgcolor=$color colspan=2><h5>$event_type<td align=right><h5>$count \n";
      $order_hash{$order} = "<td bgcolor=$color colspan=4><h5>$event_type<td align=right><h5>$count";
    }
    $selectcount++;
    $section_tot += $count if $text !~ /No Events/;
  }

  @order_keys = sort keys %order_hash;
  foreach $key (@order_keys)
  {
    ##print "key=$key\n";
    $bg = &bg;
    print HTML "<tr $bg>$order_hash{$key} \n";
  }

  &msg("Selected $selectcount summary_tot Event rows");
  print HTML "<tr><th colspan=4 bgcolor=slate align=left><h5>Total Events:<th bgcolor=slate align=right><h5>$section_tot\n";

  print HTML "<tr><td colspan=5><hr>\n";


  #
  # Non-Event Exceptions
  #

  print HTML "<tr bgcolor=slate>
    <td colspan=4><h5><center>Non-Event Exceptions</center> 
    <td><h5><center>Instance Count</center> 
    \n";

  $statement  = "select text, color, sum(count) from dbamon.summary_tot where dbamonmode like '${modelc}%' and text not like '%Event%' group by text, color order by 3 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $text   = $Data[0];
    $color  = $Data[1];
    $color= "blue" if $color eq "slate   ";
    ##print "color=>$color< \n";
    $count  = $Data[2];
    $bg = &bg;
    if ($color =~ /black/ || $color =~ /green/ || $color =~ /blue/ || $color =~ /gray/)
    {
      print HTML "<tr $bg><td bgcolor=$color colspan=4><h5><font face=$font color=silver>$text</font><td align=right><h5>$count \n";
    }
    else
    {
      print HTML "<tr $bg><td bgcolor=$color colspan=4><h5>$text<td align=right><h5>$count \n";
    }
    $selectcount++;
  }
  &msg("Selected $selectcount summary_tot NO Event rows");

  #
  # DBMS Scoreboard
  #

  print HTML "<tr><td colspan=5><hr>\n";

  #TEST1
  print HTML "</table><table width=$table_width>\n";

  print HTML "<tr bgcolor=slate>
    <th><h5>DBMS/Appl.
    <th><h5>Instance<br>Count 
    <th><h5>% Of All<br>Instances
    <th><h5>Low<br>Version
    <th><h5>High<br>Version
    <th><h5>Database<br>Count
    <th><h5>gB Space<br>Allocated
    \n";

  $statement  = "select dbms, min(v_low), max(v_high), sum(count), sum(db_count), sum(gb_alloc) from dbamon.summary_dbms where dbamonmode like '${modelc}%' group by dbms order by 4 desc";
  print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $dbms   = $Data[0];
    $v_low  = $Data[1];
    $v_high = $Data[2];
    $count  = $Data[3];
    $dbcnt  = $Data[4];
    $gbtot  = $Data[5];

    push(@dbmslist,$dbms);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = int(($count/$detail_tot) * 100); }

    &msg("dbms=$dbms count=$count - detail_tot=$detail_tot pct=$pct");

    if ($dbms eq "Informix-UX     ") { $color = "darkblue" ; }
    if ($dbms eq "OracleDB-UX     ") { $color = "red"      ; }
    if ($dbms eq "OracleApps      ") { $color = "darkred"  ; }
    if ($dbms eq "SAP             ") { $color = "violet"   ; }
    if ($dbms eq "OracleDB-NT     ") { $color = "ff0090"   ; }
    if ($dbms eq "MSSQL           ") { $color = "green"    ; }

    $bg = &bg;
    $_ = $dbms;
    s/ //g;
    $dbmslc = lc $_;
    $url = "dbamon_sys_dbms_${dbmslc}_${modelc}.html";

    $gbtot = sprintf("%7.2f",$gbtot);
    $gbtot = "" if $gbtot == 0;

    #---- Remove any leading zeros from v_low/high
    $v_low  = substr($v_low, 1) if $v_low  =~ /^0/;
    $v_high = substr($v_high,1) if $v_high =~ /^0/;

    print HTML "<tr $bg>
      <td><h5><a href='$url'><font face=$font color=$color>$dbms</a></font>
      <td align=right><h5>$count
      <td align=right><h5>${pct}%
      <td nowrap><h5><a href='/cgi-bin/dbamon_dbms.pl'>$v_low</a>
      <td nowrap><h5><a href='/cgi-bin/dbamon_dbms.pl'>$v_high</a>
      <td align=right><h5>$dbcnt   
      <td align=right><h5>$gbtot   
      \n";

    $tot_gbtot += $gbtot;
    $tot_dbcnt += $dbcnt;
  }
  print HTML "<tr bgcolor=slate><td><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count<td><td><td>
    <td align=right><h5>$tot_dbcnt<td align=right><h5>$tot_gbtot\n" ;

  $g_tot_dbms = $tot_count;
  &msg("DBMS Scoreboard - tot_count=$tot_count g_tot_dbms=$g_tot_dbms health_tot=$health_tot");

  #TEST1
  print HTML "</table><table width=$table_width>\n";

  if ($health_tot != $g_tot_dbms)
  {
    &error("Killing Myself - health_tot=$health_tot does not match the g_tot_dbms=$g_tot_dbms",2,1); 
  }

  # Check total against DBC file count
  if ($health_tot < ($dbc_count - 5))
  {
    &error("Killing Myself - health_tot=$health_tot is < (dbc_count=$dbc_count - 5)",2,1); 
  }

  &scoreboardID1 if $id1_breakout eq "Y";
  &scoreboardID2 if $id2_breakout eq "Y";
  &scoreboardID3 if $id3_breakout eq "Y";
  &scoreboardID4 if $id4_breakout eq "Y";
  &scoreboardID5 if $id5_breakout eq "Y";
  &scoreboardID6 if $id6_breakout eq "Y";
  &scoreboardID7 if $id7_breakout eq "Y";
  &scoreboardID8 if $id8_breakout eq "Y";
  &scoreboardID9 if $id9_breakout eq "Y";
  &scoreboardID10 if $id10_breakout eq "Y";
  &scoreboardLOC if $loc_breakout eq "Y";

  &scoreboardReports ;

  &makeDetailPriSby ;
  &makeDetailBkType ;

  print HTML "</table><hr>\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardLOC
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>Server Network Location<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(serverloc,'[Null]'), count(*) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by serverloc order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $loc   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(serverloc,'[Null]') = '$loc' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "loc=$loc count=$count health=$health\n";

    &healthcolors;

    push(@loclist,$loc);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $loc;
    s/ //g;
    s/\./_/g;
    $loclc = lc $_;
    $url = "dbamon_sys_loc_${loclc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$loc</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardReports
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>Misc. Instance Reports <th><h5>Count\n";

  $statement  = "select count(*) 
    from dbamon.pri_sby 
    where dbamonmode like '$modelc%'
    ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $count = $Data[0];
    $selectcount++;
    $bg = &bg;
    $url = "pri_sby_$modelc.html";
    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>Oracle/UX Primary-Standby Pairs</a></font><td align=right><h5>$count \n";
  }

  $bg = &bg;
  print HTML "<tr $bg><td colspan=2><h5><a href='bktype_$modelc.html'><font face=$font>All Instances Backup Type</a></font><td align=right>\n";

  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right>" ;
}


#-----------------------------------------------------------------------------
sub scoreboardID1
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID1 Value ($id1_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id1,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id1 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id1   = $Data[0];
    $count = $Data[1];
 
    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id1,'[Null]') = '$id1' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id1=$id1 count=$count health=$health\n";

    &healthcolors;

    push(@id1list,$id1);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id1;
    s/ //g;
    $id1lc = lc $_;
    $url = "dbamon_sys_id1_${id1lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id1</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardID2
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID2 Value ($id2_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id2,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id2 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id2   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id2,'[Null]') = '$id2' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id2=$id2 count=$count health=$health\n";

    &healthcolors;

    push(@id2list,$id2);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id2;
    s/ //g;
    $id2lc = lc $_;
    $url = "dbamon_sys_id2_${id2lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id2</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardID3
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID3 Value ($id3_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id3,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id3 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id3   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id3,'[Null]') = '$id3' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id3=$id3 count=$count health=$health\n";

    &healthcolors;

    push(@id3list,$id3);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id3;
    s/ //g;
    $id3lc = lc $_;
    $url = "dbamon_sys_id3_${id3lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id3</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}


#-----------------------------------------------------------------------------
sub scoreboardID4
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID4 Value ($id4_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id4,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id4 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id4   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id4,'[Null]') = '$id4' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id4=$id4 count=$count health=$health\n";

    &healthcolors;

    push(@id4list,$id4);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id4;
    s/ //g;
    $id4lc = lc $_;
    $url = "dbamon_sys_id4_${id4lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id4</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}


#-----------------------------------------------------------------------------
sub scoreboardID5
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID5 Value ($id5_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id5,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id5 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id5   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id5,'[Null]') = '$id5' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id4=$id5 count=$count health=$health\n";

    &healthcolors;

    push(@id5list,$id5);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id5;
    s/ //g;
    $id5lc = lc $_;
    $url = "dbamon_sys_id5_${id5lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id5</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardID6
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID6 Value ($id6_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id6,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id6 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id6   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id6,'[Null]') = '$id6' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id6=$id6 count=$count health=$health\n";

    &healthcolors;

    push(@id6list,$id6);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id6;
    s/ //g;
    $id6lc = lc $_;
    $url = "dbamon_sys_id6_${id6lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id6</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}


#-----------------------------------------------------------------------------
sub scoreboardID7
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID7 Value ($id7_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id7,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id7 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id7   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id7,'[Null]') = '$id7' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id7=$id7 count=$count health=$health\n";

    &healthcolors;

    push(@id7list,$id7);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id7;
    s/ //g;
    $id7lc = lc $_;
    $url = "dbamon_sys_id7_${id7lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id7</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardID8
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID8 Value ($id8_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id8,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id8 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id8   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id8,'[Null]') = '$id8' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id8=$id8 count=$count health=$health\n";

    &healthcolors;

    push(@id8list,$id8);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id8;
    s/ //g;
    $id8lc = lc $_;
    $url = "dbamon_sys_id8_${id8lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id8</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}


#-----------------------------------------------------------------------------
sub scoreboardID9
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID9 Value ($id9_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id9,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id9 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id9   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id9,'[Null]') = '$id9' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id9=$id9 count=$count health=$health\n";

    &healthcolors;

    push(@id9list,$id9);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id9;
    s/ //g;
    $id9lc = lc $_;
    $url = "dbamon_sys_id9_${id9lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id9</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}



#-----------------------------------------------------------------------------
sub scoreboardID10
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID10 Value ($id10_label)<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id10,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id10 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id10   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id10,'[Null]') = '$id10' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id10=$id10 count=$count health=$health\n";

    &healthcolors;

    push(@id10list,$id10);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id10;
    s/ //g;
    $id10lc = lc $_;
    $url = "dbamon_sys_id10_${id10lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id10</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr bgcolor=slate><td colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}








#-----------------------------------------------------------------------------
sub makeDetailBkType
#-----------------------------------------------------------------------------
{
  $thisdbms = $_[0];
  $_ = $thisdbms;
  s/ //g;
  $thisdbmslc = lc $_;
  $thisdbms = $_;
  &msg("Creating Backup Type report");
  $htmlfile = "/opt/dbamon/htm/bktype_$modelc.html";
  open(HTMLPS, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLPS "<title>DBAmon Backup Type Report - Mode: $mode</title>\n" ;
  print HTMLPS "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLPS "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLPS "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLPS "<tr bgcolor=wheat><td><font face=$font size=5><center>DBAmon Backup Type Report</center>\n";
  print HTMLPS "</table>\n" ;

  print HTMLPS "$links";

  print HTMLPS "<hr>\n" ;

  print HTMLPS "<p><font face=$font size=3><b>Backup Type Report</font></b>\n" ;
  print HTMLPS "<table border=0>\n" ;

  print HTMLPS "<tr bgcolor=slate>
                  <th nowrap><h5>DBMS
                  <th nowrap><h5>Backup<br>Type
                  <th nowrap><h5>Instance<br>Count
                  \n";

  print HTMLPS "</tr>\n" ;

  $statement  = "
    select 
      dbms, 
      misc1,
      count(*)
    from
      dbamon.instances
    where
      dbamonmode like '${modelc}%'
    group by
      dbms, 
      misc1
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $dbms   = $Data[0];
    $bktype = $Data[1];
    $count  = $Data[2];

    #print "task=$task age=$age\n";
    #foreach (@Data) { print "rec=$_\n"; }

    $bg = &bg;

    print HTMLPS 
      "<tr $bg height=21> 
        <td nowrap><h5>$dbms
        <td nowrap><h5>$bktype
        <td nowrap><h5>$count 
    ";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for dbms=$thisdbms");
  close(HTMLPS);
}

#-----------------------------------------------------------------------------
sub makeDetailPriSby
#-----------------------------------------------------------------------------
{
  $thisdbms = $_[0];
  $_ = $thisdbms;
  s/ //g;
  $thisdbmslc = lc $_;
  $thisdbms = $_;
  &msg("Creating PriSby detail report");
  $htmlfile = "/opt/dbamon/htm/pri_sby_$modelc.html";
  open(HTMLPS, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLPS "<title>DBAmon Oracle Primary/Standby Report - Mode: $mode</title>\n" ;
  print HTMLPS "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLPS "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLPS "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLPS "<tr bgcolor=wheat><td><font face=$font size=5><center>Oracle Primary/Standby Report</center>\n";
  print HTMLPS "</table>\n" ;

  print HTMLPS "$links";

  print HTMLPS "<hr>\n" ;

  print HTMLPS "<p><font face=$font size=3><b>Oracle Primary/Standby Pairs</font></b>\n" ;
  print HTMLPS "<table border=0>\n" ;

  print HTMLPS "<tr bgcolor=slate>
                  <th nowrap><h5>Primary<br> Host 
                  <th nowrap><h5>Primary<br> ORACLE_SID 
                  <th nowrap><h5>Standby<br> Host 
                  <th nowrap><h5>Standby<br> ORACLE_SID 
                  <th nowrap><h5>Most Recent<br>Primary/Standby<br>Timestamp Delta
                  <th nowrap><h5>DBMS
                  <th nowrap><h5>As-Of\n";

  print HTMLPS "</tr>\n" ;

  $statement  = "
    select 
      pri_host,
      pri_sid,
      sby_host,
      sby_sid,
      dbms, 
      mr_delta, 
      to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\')
    from 
      dbamon.pri_sby 
    where 
      dbamonmode like '${modelc}%' 
    order by 1, 2, 3, 4
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $pri_host = $Data[0];
    $pri_sid  = $Data[1];
    $sby_host = $Data[2];
    $sby_sid  = $Data[3];
    $dbms     = $Data[4];
    $mr_delta = $Data[5];
    $ts       = $Data[6];

    #print "task=$task age=$age\n";
    #foreach (@Data) { print "rec=$_\n"; }

    $bg = &bg;

    print HTMLPS 
      "<tr $bg height=21> 
        <td nowrap><h5>$pri_host
        <td nowrap><h5>$pri_sid
        <td nowrap><h5>$sby_host
        <td nowrap><h5>$sby_sid
        <td nowrap align=right><h5>$mr_delta
        <td nowrap><h6>$dbms
        <td nowrap><h6>$ts\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for dbms=$thisdbms");

  print HTMLPS "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLPS "<h5>No Primary/Standby Pairs Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLPS "<h5>$selectcount Primary/Standby Pairs Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLPS);
}







#-----------------------------------------------------------------------------
sub makeDetailDBMS
#-----------------------------------------------------------------------------
{
  $thisdbms = $_[0];
  $_ = $thisdbms;
  s/ //g;
  $thisdbmslc = lc $_;
  $thisdbms = $_;
  ##&msg("Creating detail section for dbms=$thisdbms");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_dbms_${thisdbmslc}_${modelc}.html";
  open(HTMLDBMS, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLDBMS "<title>DBAmon Instance Summary - DBMS/Appl.: $thisdbms - Mode: $mode</title>\n" ;
  print HTMLDBMS "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLDBMS "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLDBMS "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLDBMS "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For DBMS/Appl.: $thisdbms</center>\n";
  print HTMLDBMS "</table>\n" ;

  print HTMLDBMS "$links";

  print HTMLDBMS "<hr>\n" ;

  print HTMLDBMS "<p><font face=$font size=3><b>Instance Detail - $thisdbms Instances:</font></b>\n" ;
  print HTMLDBMS "<table border=0>\n" ;

  print HTMLDBMS "<tr bgcolor=slate>\n" ;
  print HTMLDBMS "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;

  print HTMLDBMS "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLDBMS "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLDBMS "<th><h5>Events\n" ;
  print HTMLDBMS "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLDBMS "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLDBMS "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLDBMS "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLDBMS "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLDBMS "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLDBMS "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLDBMS "<th><h5>Misc.\n" ;
  print HTMLDBMS "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLDBMS "</tr>\n" ;

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and dbms = '$thisdbms'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;
    $html =~ s/<select/\n  <select/g;

    #print "task=$task age=$age\n";
    #foreach (@Data) { print "rec=$_\n"; }

    $bg = &bg;

    print HTMLDBMS "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for dbms=$thisdbms");

  print HTMLDBMS "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLDBMS "<h5>No Instances Of This DBMS/Appl. Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLDBMS "<h5>$selectcount Instance(s) Of This DBMS/Appl. Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLDBMS);
}





#-----------------------------------------------------------------------------
sub makeDetailID1
#-----------------------------------------------------------------------------
{
  $thisid1 = $_[0];
  $_ = $thisid1;
  s/ //g;
  $thisid1lc = lc $_;
  $thisid1 = $_;
  &msg("Creating detail section for id1=$thisid1");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id1_${thisid1lc}_${modelc}.html";
  open(HTMLID1, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLID1 "<title>DBAmon Instance Summary - ID1: $thisid1 - Mode: $mode</title>\n" ;
  print HTMLID1 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID1 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID1 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID1 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID1=$thisid1</center>\n";
  print HTMLID1 "</table>\n" ;

  print HTMLID1 "$links";

  print HTMLID1 "<hr>\n" ;

  print HTMLID1 "<p><font face=$font size=3><b>Instance Detail - ID1=$thisid1 Instances:</font></b>\n" ;
  print HTMLID1 "<table border=0>\n" ;

  print HTMLID1 "<tr bgcolor=slate>\n" ;
  print HTMLID1 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID1 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID1 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID1 "<th><h5>Events\n" ;
  print HTMLID1 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID1 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID1 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID1 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID1 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID1 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID1 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID1 "<th><h5>Misc.\n" ;
  print HTMLID1 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID1 "</tr>\n" ;

  if ($thisid1 eq "[Null]") { $sqlid1 = "is NULL"; }
  else                      { $sqlid1 = "= '$thisid1'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id1 $sqlid1
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID1 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID1=$thisid1");

  ##print HTMLID1 "</form>\n" ;
  print HTMLID1 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID1 "<h5>No Instances Of This ID1 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID1 "<h5>$selectcount Instance(s) Of This ID1 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID1);
}

#-----------------------------------------------------------------------------
sub makeDetailID2
#-----------------------------------------------------------------------------
{
  $thisid2 = $_[0];
  $_ = $thisid2;
  s/ //g;
  $thisid2lc = lc $_;
  $thisid2 = $_;
  &msg("Creating detail section for id2=$thisid2");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id2_${thisid2lc}_${modelc}.html";
  open(HTMLID2, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLID2 "<title>DBAmon Instance Summary - ID2: $thisid2 - Mode: $mode</title>\n" ;
  print HTMLID2 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID2 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID2 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID2 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID2=$thisid2</center>\n";
  print HTMLID2 "</table>\n" ;

  print HTMLID2 "$links";

  print HTMLID2 "<hr>\n" ;

  print HTMLID2 "<p><font face=$font size=3><b>Instance Detail - ID2=$thisid2 Instances:</font></b>\n" ;
  print HTMLID2 "<table border=0>\n" ;

  print HTMLID2 "<tr bgcolor=slate>\n" ;
  print HTMLID2 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID2 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID2 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID2 "<th><h5>Events\n" ;
  print HTMLID2 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID2 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID2 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID2 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID2 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID2 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID2 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID2 "<th><h5>Misc.\n" ;
  print HTMLID2 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID2 "</tr>\n" ;

  if ($thisid2 eq "[Null]") { $sqlid2 = "is NULL"; }
  else                      { $sqlid2 = "= '$thisid2'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id2 $sqlid2
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID2 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID2=$thisid2");

  ##print HTMLID2 "</form>\n" ;
  print HTMLID2 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID2 "<h5>No Instances Of This ID2 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID2 "<h5>$selectcount Instance(s) Of This ID2 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID2);
}





#-----------------------------------------------------------------------------
sub makeDetailID3
#-----------------------------------------------------------------------------
{
  $thisid3 = $_[0];
  $_ = $thisid3;
  s/ //g;
  $thisid3lc = lc $_;
  $thisid3 = $_;
  &msg("Creating detail section for id3=$thisid3");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id3_${thisid3lc}_${modelc}.html";
  open(HTMLID3, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLID3 "<title>DBAmon Instance Summary - ID3: $thisid3 - Mode: $mode</title>\n" ;
  print HTMLID3 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID3 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID3 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID3 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID3=$thisid3</center>\n";
  print HTMLID3 "</table>\n" ;

  print HTMLID3 "$links";

  print HTMLID3 "<hr>\n" ;

  print HTMLID3 "<p><font face=$font size=3><b>Instance Detail - ID3=$thisid3 Instances:</font></b>\n" ;
  print HTMLID3 "<table border=0>\n" ;

  print HTMLID3 "<tr bgcolor=slate>\n" ;
  print HTMLID3 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID3 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID3 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID3 "<th><h5>Events\n" ;
  print HTMLID3 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID3 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID3 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID3 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID3 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID3 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID3 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID3 "<th><h5>Misc.\n" ;
  print HTMLID3 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID3 "</tr>\n" ;

  if ($thisid3 eq "[Null]") { $sqlid3 = "is NULL"; }
  else                      { $sqlid3 = "= '$thisid3'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id3 $sqlid3
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID3 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID3=$thisid3");

  ##print HTMLID3 "</form>\n" ;
  print HTMLID3 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID3 "<h5>No Instances Of This ID3 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID3 "<h5>$selectcount Instance(s) Of This ID3 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID3);
}

#-----------------------------------------------------------------------------
sub makeDetailID4
#-----------------------------------------------------------------------------
{
  $thisid4 = $_[0];
  $_ = $thisid4;
  s/ //g;
  $thisid4lc = lc $_;
  $thisid4 = $_;
  &msg("Creating detail section for id4=$thisid4");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id4_${thisid4lc}_${modelc}.html";
  open(HTMLID4, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLID4 "<title>DBAmon Instance Summary - ID4: $thisid4 - Mode: $mode</title>\n" ;
  print HTMLID4 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID4 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID4 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID4 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID4=$thisid4</center>\n";
  print HTMLID4 "</table>\n" ;

  print HTMLID4 "$links";

  print HTMLID4 "<hr>\n" ;

  print HTMLID4 "<p><font face=$font size=3><b>Instance Detail - ID4=$thisid4 Instances:</font></b>\n" ;
  print HTMLID4 "<table border=0>\n" ;

  print HTMLID4 "<tr bgcolor=slate>\n" ;
  print HTMLID4 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID4 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID4 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID4 "<th><h5>Events\n" ;
  print HTMLID4 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID4 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID4 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID4 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID4 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID4 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID4 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID4 "<th><h5>Misc.\n" ;
  print HTMLID4 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID4 "</tr>\n" ;

  if ($thisid4 eq "[Null]") { $sqlid4 = "is NULL"; }
  else                      { $sqlid4 = "= '$thisid4'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id4 $sqlid4
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID4 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID4=$thisid4");

  ##print HTMLID4 "</form>\n" ;
  print HTMLID4 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID4 "<h5>No Instances Of This ID4 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID4 "<h5>$selectcount Instance(s) Of This ID4 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID4);
}

#-----------------------------------------------------------------------------
sub makeDetailID5
#-----------------------------------------------------------------------------
{
  $thisid5 = $_[0];
  $_ = $thisid5;
  s/ //g;
  $thisid5lc = lc $_;
  $thisid5 = $_;
  &msg("Creating detail section for id5=$thisid5");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id5_${thisid5lc}_${modelc}.html";
  open(HTMLID5, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLID5 "<title>DBAmon Instance Summary - ID5: $thisid5 - Mode: $mode</title>\n" ;
  print HTMLID5 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID5 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID5 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID5 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID5=$thisid5</center>\n";
  print HTMLID5 "</table>\n" ;

  print HTMLID5 "$links";

  print HTMLID5 "<hr>\n" ;

  print HTMLID5 "<p><font face=$font size=3><b>Instance Detail - ID5=$thisid5 Instances:</font></b>\n" ;
  print HTMLID5 "<table border=0>\n" ;

  print HTMLID5 "<tr bgcolor=slate>\n" ;
  print HTMLID5 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID5<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID5 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID5 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID5 "<th><h5>Events\n" ;
  print HTMLID5 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID5 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID5 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID5 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID5 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID5 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID5 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID5 "<th><h5>Misc.\n" ;
  print HTMLID5 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID5 "</tr>\n" ;

  if ($thisid5 eq "[Null]") { $sqlid5 = "is NULL"; }
  else                      { $sqlid5 = "= '$thisid5'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id5 $sqlid5
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID5 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID5=$thisid5");

  ##print HTMLID5 "</form>\n" ;
  print HTMLID5 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID5 "<h5>No Instances Of This ID5 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID5 "<h5>$selectcount Instance(s) Of This ID5 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID5);
}

#-----------------------------------------------------------------------------
sub makeDetailID6
#-----------------------------------------------------------------------------
{
  $thisid6 = $_[0];
  $_ = $thisid6;
  s/ //g;
  $thisid6lc = lc $_;
  $thisid6 = $_;
  &msg("Creating detail section for id6=$thisid6");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id6_${thisid6lc}_${modelc}.html";
  open(HTMLID6, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLID6 "<title>DBAmon Instance Summary - ID6: $thisid6 - Mode: $mode</title>\n" ;
  print HTMLID6 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID6 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID6 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID6 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID6=$thisid6</center>\n";
  print HTMLID6 "</table>\n" ;

  print HTMLID6 "$links";

  print HTMLID6 "<hr>\n" ;

  print HTMLID6 "<p><font face=$font size=3><b>Instance Detail - ID6=$thisid6 Instances:</font></b>\n" ;
  print HTMLID6 "<table border=0>\n" ;

  print HTMLID6 "<tr bgcolor=slate>\n" ;
  print HTMLID6 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID6<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID6 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID6 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID6 "<th><h5>Events\n" ;
  print HTMLID6 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID6 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID6 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID6 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID6 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID6 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID6 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID6 "<th><h5>Misc.\n" ;
  print HTMLID6 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID6 "</tr>\n" ;

  if ($thisid6 eq "[Null]") { $sqlid6 = "is NULL"; }
  else                      { $sqlid6 = "= '$thisid6'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id6 $sqlid6
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID6 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID6=$thisid6");

  ##print HTMLID6 "</form>\n" ;
  print HTMLID6 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID6 "<h5>No Instances Of This ID6 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID6 "<h5>$selectcount Instance(s) Of This ID6 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID6);
}

#-----------------------------------------------------------------------------
sub makeDetailID7
#-----------------------------------------------------------------------------
{
  $thisid7 = $_[0];
  $_ = $thisid7;
  s/ //g;
  $thisid7lc = lc $_;
  $thisid7 = $_;
  &msg("Creating detail section for id7=$thisid7");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id7_${thisid7lc}_${modelc}.html";

  #open(HTMLID7, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");
  open(HTMLID7, ">$htmlfile") || &msg("Cannot open output $htmlfile - $!");

  print HTMLID7 "<title>DBAmon Instance Summary - ID7: $thisid7 - Mode: $mode</title>\n" ;
  print HTMLID7 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID7 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID7 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID7 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID7=$thisid7</center>\n";
  print HTMLID7 "</table>\n" ;

  print HTMLID7 "$links";

  print HTMLID7 "<hr>\n" ;

  print HTMLID7 "<p><font face=$font size=3><b>Instance Detail - ID7=$thisid7 Instances:</font></b>\n" ;
  print HTMLID7 "<table border=0>\n" ;

  print HTMLID7 "<tr bgcolor=slate>\n" ;
  print HTMLID7 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID7<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID7 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID7 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID7 "<th><h5>Events\n" ;
  print HTMLID7 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID7 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID7 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID7 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID7 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID7 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID7 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID7 "<th><h5>Misc.\n" ;
  print HTMLID7 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID7 "</tr>\n" ;

  if ($thisid7 eq "[Null]") { $sqlid7 = "is NULL"; }
  else                      { $sqlid7 = "= '$thisid7'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id7 $sqlid7
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID7 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID7=$thisid7");

  ##print HTMLID7 "</form>\n" ;
  print HTMLID7 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID7 "<h5>No Instances Of This ID7 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID7 "<h5>$selectcount Instance(s) Of This ID7 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID7);
}

#-----------------------------------------------------------------------------
sub makeDetailID9
#-----------------------------------------------------------------------------
{
  $thisid9 = $_[0];
  $_ = $thisid9;
  s/ //g;
  $thisid9lc = lc $_;
  $thisid9 = $_;
  &msg("Creating detail section for id9=$thisid9");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id9_${thisid9lc}_${modelc}.html";

  #open(HTMLID9, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");
  open(HTMLID9, ">$htmlfile") || &msg("Cannot open output $htmlfile - $!");

  print HTMLID9 "<title>DBAmon Instance Summary - ID9: $thisid9 - Mode: $mode</title>\n" ;
  print HTMLID9 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID9 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID9 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID9 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID9=$thisid9</center>\n";
  print HTMLID9 "</table>\n" ;

  print HTMLID9 "$links";

  print HTMLID9 "<hr>\n" ;

  print HTMLID9 "<p><font face=$font size=3><b>Instance Detail - ID9=$thisid9 Instances:</font></b>\n" ;
  print HTMLID9 "<table border=0>\n" ;

  print HTMLID9 "<tr bgcolor=slate>\n" ;
  print HTMLID9 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID9<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID9 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID9 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID9 "<th><h5>Events\n" ;
  print HTMLID9 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID9 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID9 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID9 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID9 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID9 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID9 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID9 "<th><h5>Misc.\n" ;
  print HTMLID9 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID9 "</tr>\n" ;

  if ($thisid9 eq "[Null]") { $sqlid9 = "is NULL"; }
  else                      { $sqlid9 = "= '$thisid9'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id9 $sqlid9
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID9 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID9=$thisid9");

  ##print HTMLID9 "</form>\n" ;
  print HTMLID9 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID9 "<h5>No Instances Of This ID9 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID9 "<h5>$selectcount Instance(s) Of This ID9 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID9);
}

#-----------------------------------------------------------------------------
sub makeDetailID10
#-----------------------------------------------------------------------------
{
  $thisid10 = $_[0];
  $_ = $thisid10;
  s/ //g;
  $thisid10lc = lc $_;
  $thisid10 = $_;
  &msg("Creating detail section for id10=$thisid10");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id10_${thisid10lc}_${modelc}.html";

  #open(HTMLID10, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");
  open(HTMLID10, ">$htmlfile") || &msg("Cannot open output $htmlfile - $!");

  print HTMLID10 "<title>DBAmon Instance Summary - ID10: $thisid10 - Mode: $mode</title>\n" ;
  print HTMLID10 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID10 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID10 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID10 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID10=$thisid10</center>\n";
  print HTMLID10 "</table>\n" ;

  print HTMLID10 "$links";

  print HTMLID10 "<hr>\n" ;

  print HTMLID10 "<p><font face=$font size=3><b>Instance Detail - ID10=$thisid10 Instances:</font></b>\n" ;
  print HTMLID10 "<table border=0>\n" ;

  print HTMLID10 "<tr bgcolor=slate>\n" ;
  print HTMLID10 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID10<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID10 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID10 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID10 "<th><h5>Events\n" ;
  print HTMLID10 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID10 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID10 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID10 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID10 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID10 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID10 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID10 "<th><h5>Misc.\n" ;
  print HTMLID10 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID10 "</tr>\n" ;

  if ($thisid10 eq "[Null]") { $sqlid10 = "is NULL"; }
  else                      { $sqlid10 = "= '$thisid10'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id10 $sqlid10
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID10 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID10=$thisid10");

  ##print HTMLID10 "</form>\n" ;
  print HTMLID10 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID10 "<h5>No Instances Of This ID10 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID10 "<h5>$selectcount Instance(s) Of This ID10 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID10);
}













#-----------------------------------------------------------------------------
sub makeDetailID8
#-----------------------------------------------------------------------------
{
  $thisid8 = $_[0];
  $_ = $thisid8;
  s/ //g;
  $thisid8lc = lc $_;
  $thisid8 = $_;
  &msg("Creating detail section for id8=$thisid8");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id8_${thisid8lc}_${modelc}.html";
  open(HTMLID8, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLID8 "<title>DBAmon Instance Summary - ID8: $thisid8 - Mode: $mode</title>\n" ;
  print HTMLID8 "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID8 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID8 "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLID8 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID8=$thisid8</center>\n";
  print HTMLID8 "</table>\n" ;

  print HTMLID8 "$links";

  print HTMLID8 "<hr>\n" ;

  print HTMLID8 "<p><font face=$font size=3><b>Instance Detail - ID8=$thisid8 Instances:</font></b>\n" ;
  print HTMLID8 "<table border=0>\n" ;

  print HTMLID8 "<tr bgcolor=slate>\n" ;
  print HTMLID8 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID8<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLID8 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID8 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID8 "<th><h5>Events\n" ;
  print HTMLID8 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID8 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID8 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID8 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID8 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID8 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID8 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID8 "<th><h5>Misc.\n" ;
  print HTMLID8 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID8 "</tr>\n" ;

  if ($thisid8 eq "[Null]") { $sqlid8 = "is NULL"; }
  else                      { $sqlid8 = "= '$thisid8'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id8 $sqlid8
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID8 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID8=$thisid8");

  ##print HTMLID8 "</form>\n" ;
  print HTMLID8 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID8 "<h5>No Instances Of This ID8 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID8 "<h5>$selectcount Instance(s) Of This ID8 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID8);
}

#-----------------------------------------------------------------------------
sub makeDetailLOC
#-----------------------------------------------------------------------------
{
  $thisloc = $_[0];
  $_ = $thisloc;
  s/ //g;
  $thisloc_sql = $_;
  s/\./_/g;
  $thisloclc = lc $_;
  $thisloc = $_;
  &msg("Creating detail section for loc=$thisloc");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_loc_${thisloclc}_${modelc}.html";
  open(HTMLLOC, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLLOC "<title>DBAmon Instance Summary - LOC: $thisloc - Mode: $mode</title>\n" ;
  print HTMLLOC "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLLOC "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLLOC "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg'  width=$table_width>\n" ;
  print HTMLLOC "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For Server Network Location:<br>$thisloc_sql</center>\n";
  print HTMLLOC "</table>\n" ;

  print HTMLLOC "$links";

  print HTMLLOC "<hr>\n" ;

  print HTMLLOC "<p><font face=$font size=3><b>Instance Detail - Server Network Location=$thisloc_sql Instances:</font></b>\n" ;
  print HTMLLOC "<table border=0>\n" ;

  print HTMLLOC "<tr bgcolor=slate>\n" ;
  print HTMLID4 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> Tag 
    <br>STAR <font color=pink>server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLLOC "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLLOC "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLLOC "<th><h5>Events\n" ;
  print HTMLLOC "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLLOC "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLLOC "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLLOC "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLLOC "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLLOC "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLLOC "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLLOC "<th><h5>Misc.\n" ;
  print HTMLLOC "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLLOC "</tr>\n" ;

  if ($thisloc eq "[Null]") { $sqlloc = "is NULL"; }
  else                      { $sqlloc = "= '$thisloc_sql'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and serverloc $sqlloc
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLLOC "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for Server Network Location=$thisloc_sql");

  ##print HTMLLOC "</form>\n" ;
  print HTMLLOC "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLLOC "<h5>No Instances Of This Server Network Location Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLLOC "<h5>$selectcount Instance(s) Of This LOC Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLLOC);
}

#-----------------------------------------------------------------------------
sub instanceDetail
#-----------------------------------------------------------------------------
{
  &msg("instanceDetail() - Creating detail section");
  
  open(HTMLDET, ">/opt/dbamon/htm/$detpath") || &error("Cannot open output $detpath - $!");

  print HTMLDET "<a name='ALPHA'>\n";
  print HTMLDET "<table width=$table_width>\n";
  print HTMLDET "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Instance Detail<br>($detail_tot Instance(s) on $server_count Server(s) - $total_space gB Total Size - DBAmon Tasks: $task_count - Avg. Iteration Time: $task_avgtm Min.)</center></font></b>\n";
  print HTMLDET "</table>\n";

  #print HTMLDET "<font face=$font size=3><b>Instance Detail ($detail_tot Instance(s) on $server_count Server(s) - $total_space gB Total Size - DBAmon Tasks: $task_count - Avg. Iteration Time: $task_avgtm Min.):</font></b>\n" ;

  print HTMLDET "<table border=0>\n" ;

  print HTMLDET "<tr bgcolor=slate>\n" ;
  print HTMLDET  "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLDET "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLDET "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLDET "<th><h5>Events\n" ;
  print HTMLDET "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLDET "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLDET "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLDET "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLDET "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLDET "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLDET "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLDET "<th><h5>Misc.\n" ;
  print HTMLDET "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLDET "</tr>\n" ;

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    ##print "FOUND title=$title selectcount=$selectcount \n";

    $bg = &bg;
    print HTMLDET "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
    push(@instance_list,$title);
  }
  ##print HTMLDET "</form>\n" ;
  print HTMLDET "</table><hr>\n" ;
  close(HTMLDET);
  &msg("Selected $selectcount summary_detail rows");
}

#-----------------------------------------------------------------------------
sub uptime
#-----------------------------------------------------------------------------
{
  $t = $_[0];
  $statement  = "
    select
      avg(tot_pct)
    from 
      dbamon.uptime_summary
    where 
      instance = '$t'
      and ts >= sysdate - 30";
  ##print "statement=$statement\n";
  $sth2 = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $color = "lime"; 

  while (@Data = $sth2->fetchrow_array)
  {
    $u = $Data[0];
  }

  $u = int($u);
  $u = sprintf("%5.1f",$u);

  if ($u ne "")
  {
    if    ($u >= 99) { $c = "green"; } 
    elsif ($u >= 95) { $c = "yellow"; } 
    else             { $c = "red"; } 
    $s = "<font color=$c><h5>$u%</font>";
  }
  else 
  {
    $s = "";
  }
  print "t=$t u=$u s=$s \n";
  return $s;
}

#-----------------------------------------------------------------------------
sub makeEventIsolate
#-----------------------------------------------------------------------------
{
  ($this_msgid) = @_;

  if (index($events_processed,$this_msgid) == -1)
  {
    print HTMLEVENT "</table><hr><font size=1>($events_counter Event(s))</font>";
   
    if ($events_optional_text)
    {
      print HTMLEVENT "<br><b><font size=1>($events_optional_text $events_optional_num)</font></b>";
    }

    close(HTMLEVENT);

    $htmlfile = "/opt/dbamon/htm/event_${this_msgid}_${modelc}.html";
    open(HTMLEVENT, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

    print HTMLEVENT "<title>DBAmon Event Detail - Mode: $mode</title>\n" ;
    print HTMLEVENT "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
    print HTMLEVENT "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
    print HTMLEVENT "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
    print HTMLEVENT "<tr bgcolor=wheat><td><font face=$font size=5><center>$this_msgid Events</center>\n";
    print HTMLEVENT "</table>\n" ;

    print HTMLEVENT "$links\n" ;
    print HTMLEVENT "<hr>\n" ;
    print HTMLEVENT "<table border=0><tr bgcolor=slate><th><h5>MsgID<th><h5>Event Timestamp<th><h5>DBMS<th><h5>Event Text\n";
    
    $events_processed .= "$this_msgid ";
    $events_counter = 0;
    $events_optional_text = "";
    $events_optional_num  = 0;

    $isolated_urls .= "<a href='/dbamon/event_${this_msgid}_${modelc}.html'><b>$this_msgid</b></a> ";
  }

  $events_counter++;
  print HTMLEVENT "$eventline";

  if ($this_msgid eq "DBA313")
  {
    $events_optional_text = "Total gB Saved: " if !$events_optional_text; 
    $znum = (split(" ",$eventline)) [25];
    $events_optional_num += $znum if $znum > 0;
    ##print "znum=$znum events_optional_num=$events_optional_num\n";
  }

}

#-----------------------------------------------------------------------------
sub makeSev
#-----------------------------------------------------------------------------
{
  $htmlfile = "/opt/dbamon/htm/sev_${modelc}.html";
  open(HTMLSEV, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLSEV "<title>DBAmon Event Detail - Mode: $mode</title>\n" ;
  print HTMLSEV "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLSEV "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLSEV "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLSEV "<tr bgcolor=wheat><td><font face=$font size=5><center>Event Detail</center>\n";
  print HTMLSEV "</table>\n" ;

  print HTMLSEV "$links\n" ;

  print HTMLSEV "<hr>\n" ;

  @sev_list = ("C","W","I","U","S","P","N");
  %sev_colors = ("C" , "red",
                 "W" , "yellow",
                 "I" , "cyan",
                 "U" , "lime",
                 "S" , "mediumpurple",
                 "P" , "lightskyblue",
                 "N" , "lime"
                );
  %sev_text   = ("C" , "Critical",
                 "W" , "Warning",
                 "I" , "Info",
                 "U" , "User",
                 "S" , "Security",
                 "P" , "Performance",
                 "N" , "Notation"
                );

  foreach $sev (@sev_list)
  {
    ##print "sev=$sev\n";
    print HTMLSEV "<a name='$sev'</a>\n";
    print HTMLSEV "<h4>Severity <font color=$sev_colors{$sev}>$sev</font> $sev_text{$sev} Events</h4>\n";
    print HTMLSEV "<table border=0><tr bgcolor=slate><th><h5>MsgID<th><h5>Event Timestamp<th><h5>DBMS<th><h5>Event Text\n";
    $statement  = "
      select
        system,
        title,
        dbms,
        text,
        msgid,
        details_url,
        to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\'),
        ticket
      from 
	dbamon.event_detail
      where 
        dbamonmode like '${modelc}%' and
	sev = '$sev'
      order by 
        msgid,
        system,
        to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\') desc";
    ##print "statement=$statement\n";
    $sth2 = $dbh->prepare($statement) ||
	    &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');

    $last_msgid = "";
    $counter = 0;
    $lastbg2 = 0;

    while (@Data = $sth2->fetchrow_array)
    {
      #$system   = $Data[0];
      $instance = $Data[1];
      $dbms     = $Data[2];
      $text     = $Data[3];
      $msgid    = $Data[4];
      $url      = $Data[5];
      $detts    = $Data[6];
      $ticket   = $Data[7];

      next if $msgid eq "DBA301";

      ##print "text=$text\n";

      if ($dbms eq "Informix-UX") { $dbms_color = "darkblue" ; }
      if ($dbms eq "OracleDB-UX") { $dbms_color = "red"      ; }
      if ($dbms eq "OracleApps") { $dbms_color = "darkred"  ; }
      if ($dbms eq "SAP") { $dbms_color = "violet"   ; }
      if ($dbms eq "OracleDB-NT") { $dbms_color = "ff0090"   ; }
      if ($dbms eq "MSSQL") { $dbms_color = "green"    ; }

      if ($msgid ne $last_msgid && $last_msgid ne "")
      {
        print HTMLSEV "<tr><td><hr size=1>\n";
        $lastbg2 = 0;
      }

      if ($ticket eq "" || $ticket eq "?")
      {
        $ticket = "N/A";
      }

      # temp - until i fix the ticket problem
      #$ticket = "";

      $bg2 = &bg2;
      $fs = "1";

      $eventline = "<tr $bg2>
        <td bgcolor=$sev_colors{$sev}><b><font size=$fs><a HREF='http://dbamon.com/errors.shtml#$msgid'>$msgid</a>
        <td nowrap><b><font size=$fs>$detts
        <td nowrap><b><font size=$fs><font color=$dbms_color>$dbms</font>
        <td><a href='$url'><b><font size=$fs>$text</a> \n";

      print HTMLSEV "$eventline";

      if (index($events_isolate,$msgid) > -1)
      {
        ##print "calling eventisolate $msgid\n";
        &makeEventIsolate($msgid);  
      }

      $counter++;

      $last_msgid = $msgid;
    }
    print HTMLSEV "</table>";
    print HTMLSEV "<h6>$counter $sev_text{$sev} Event(s)<hr></h6>";
  }
  close(HTMLSEV);

  print HTMLEVENT "</table><hr><font size=1>($events_counter Event(s))</font>";
  if ($events_optional_text)
  {
    print HTMLEVENT "<br><b><font size=1>($events_optional_text $events_optional_num)</font></b>";
  }

  close(HTMLEVENT);
}

#-----------------------------------------------------------------------------
sub newAlpha
#-----------------------------------------------------------------------------
{
  $created_alpha{$alpha} = 1;

  mkdir("/opt/dbamon/htm/alpha_$modelc",755);
  system("ln -s /opt/dbamon/htm/img /opt/dbamon/htm/alpha_$modelc/img > /dev/null 2>&1");
  system("ln -s /opt/dbamon/htm/events_current /opt/dbamon/htm/alpha_$modelc/events_current > /dev/null 2>&1");
  system("ln -s /opt/dbamon/htm/details /opt/dbamon/htm/alpha_$modelc/details > /dev/null 2>&1");
  system("ln -s /opt/dbamon/htm/reports /opt/dbamon/htm/alpha_$modelc/reports > /dev/null 2>&1");
  system("ln -s /opt/dbamon/htm/graphs /opt/dbamon/htm/alpha_$modelc/graphs > /dev/null 2>&1");
  open(HTMLALPHA, ">/opt/dbamon/htm/alpha_$modelc/$alpha.html") || &error("Cannot open output /opt/dbamon/htm/alpha_$modelc/$alpha.html - $!");
  print HTMLALPHA "<title>DBAmon Instance Summary - ALPHA: $thisid1 - Mode: $mode</title>\n" ;
  print HTMLALPHA "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLALPHA "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLALPHA "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLALPHA "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For '$alpha' Servers</center>\n";
  print HTMLALPHA "</table>\n" ;

  print HTMLALPHA "$links";

  print HTMLALPHA "<hr>\n" ;

  print HTMLALPHA "<p><font face=$font size=3><b>Instance Detail - '$alpha' Server Instance(s):</font></b>\n" ;

  print HTMLALPHA "<table border=0>\n" ;

  print HTMLALPHA "<tr bgcolor=slate>\n" ;
  print HTMLALPHA "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3
    <br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> Tag 
    <br>STAR <font color=$starcolor>Server Priority/Class/CR/Use/Supt. Team</font>
    <br>Uptime % Last 30 Days\n" ;
  print HTMLALPHA "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLALPHA "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLALPHA "<th nowrap width=300><h5>Current Events\n" ;
  print HTMLALPHA "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLALPHA "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLALPHA "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLALPHA "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLALPHA "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLALPHA "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLALPHA "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLALPHA "<th><h5>Misc.\n" ;
  print HTMLALPHA "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;
  print HTMLALPHA "</tr>\n" ;
}

#-----------------------------------------------------------------------------
sub instanceDetailAlpha
#-----------------------------------------------------------------------------
{
  &msg("instanceDetailAlpha() - Creating detail section");
  
### HERE
  $statement  = "select 
      system,
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
    order by 2, 3";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg2 = 0;

  &msg("  (After select 1)");

  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;
    $alpha  = uc substr($sytem,0,1);

    if ($title eq $last_title)
    {
      next; 
    }

    $dbms = "ServerNetAlias" if $dbms =~ /ServerAlias/;

    if ($alpha ne $last_alpha)
    {
      print HTMLALPHA "</table><p><font size=2><b>$alpha_i_count Total Instance(s)/Alias(es)</font><hr>\n" ;
      close(HTMLALPHA);
      if ($alpha_flag == 1)
      {
        $alpha_urls .= " <td align=right><h5>$alpha_i_count";
        chop($alpha_dbms_list);  # Remove trailing comma
        #$alpha_dbms_list =~ s/ //g;
        #$alpha_dbms_list =~ s/fontcolor/font color/g;
        $alpha_urls .= " <td><h5>$alpha_dbms_list\n";
        $alpha_dbms_list = "";
      }
      $alpha_flag = 1;
      $bg2 = &bg2;
      $alpha_urls .= "\n <tr $bg2><td align=center><a href='alpha_$modelc/$alpha.html'><h5>$alpha</a>";
      &newAlpha;
      $lastbg = 0;
      $alpha_i_count = 0;
    }
    $alpha_i_count++;
    if ($alpha_dbms_list !~ /$dbms/)
    {
      if ($dbms eq "Informix-UX     ") { $color = "darkblue" ; }
      if ($dbms eq "OracleDB-UX     ") { $color = "red"      ; }
      if ($dbms eq "OracleApps      ") { $color = "darkred"  ; }
      if ($dbms eq "SAP             ") { $color = "violet"   ; }
      if ($dbms eq "OracleDB-NT     ") { $color = "ff0090"   ; }
      if ($dbms eq "MSSQL           ") { $color = "green"    ; }
      if ($dbms eq "ServerNetAlias")   { $color = "brown"    ; }

      $alpha_dbms_list .= "<font color=$color>$dbms</font>,";
    }
    
    $last_alpha = $alpha;

    $bg = &bg;
    print HTMLALPHA "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;

    $last_title = $title;
  }

  $alpha_urls .= " <td align=right><h5>$alpha_i_count";
  print HTMLALPHA "</table><hr>\n" ;
  close(HTMLALPHA);
  chop($alpha_dbms_list);  # Remove trailing comma
  #$alpha_dbms_list =~ s/ //g;
  #$alpha_dbms_list =~ s/fontcolor/font color/g;
  $alpha_urls .= " <td><h5>$alpha_dbms_list\n";

  &msg("Selected $selectcount summary_detail rows - num_instances=$num_instances");
}



#-----------------------------------------------------------------------------
sub makeDetail
#-----------------------------------------------------------------------------
{
  &msg("Creating detail section");

  &instanceDetail;   # Create detailed portion - file is $detpath
  print HTML "<!--#include virtual='$detpath'-->\n";

  # Now count the number of rows in the tasks table for iteration 0. 
  # If the number of detail rows != the sum from the summary_dbms table,
  # then an update must be happening now!

  $statement  = "
    select 
      sum(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num = 0 
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $num_instances = $Data[0];
  }
  &msg("There are $num_instances instances from the task=0 dbamon.task table");

  #if ($num_instances != $selectcount)
  if ($num_instances > $selectcount)
  {
    ##&msg("The number of detail rows ($selectcount) does not match the count total ($num_instances)");
    ##&msg("from the summary_tasks table. Therefore, an update must be in process");
    ##&msg("now. Killing myself");
    ##exit 2;
    &error("Killing Myself - detail rows=$selectcount does not match the num_instances=$num_instances",2,1); 
  }
}

#-----------------------------------------------------------------------------
sub makeDetailShort
#-----------------------------------------------------------------------------
{
  $shortpath      = "/opt/dbamon/htm/tmp/instances${modelc}_$$.html.new";
  $shortpath_perm = "/opt/dbamon/htm/instances$modelc.html";

  &msg("cp'ing HTML");
  close(HTML);
  system("cp $html_sys_path_new $shortpath");
  ##system("ll $html_sys_path_new $shortpath");

  msg("Reopening output HTML file: $html_sys_path_new");
  open(HTML, ">>$html_sys_path_new") || &error("Cannot open input $html_sys_path_new - $!");

  &msg("Creating Short detail section");

  open(HTMLSHORT, ">>$shortpath") || &error("Cannot open output $shortpath - $!");

  &instanceDetailAlpha;

  print HTMLSHORT "<a name='ALPHA'>\n";
  print HTMLSHORT "<table width=$table_width>\n";
  print HTMLSHORT "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Instance Detail - By First Letter Of Server Name</center></font></b>\n";
  print HTMLSHORT "</table>\n";

  print HTMLSHORT "<table border=0 width=$table_width>
                    <tr bgcolor=slate>
                      <td align=center><h5>First<br>Letter Of<br>Server<br>Name
                      <td align=center><h5>Instance<br>Count
                      <td align=center><h5>DBMS(s)\n";
  print HTMLSHORT "$alpha_urls </table>\n";
  print HTMLSHORT "<font face=$font size=2><b><p>($server_count Total Server(s) - $health_tot Total Instance(s)/Alias(es) - $total_space gB Total DB Space)<hr>\n";

  &makeTasksShort;


}

#-----------------------------------------------------------------------------
sub makeFoot
#-----------------------------------------------------------------------------
{
  &msg("Creating foot section");

  open(HTMLTASK, ">$task_detail_file") || &error("Cannot open output $task_detail_file - $!");

  print HTMLTASK "<title>DBAmon Monitor Task Detail - Mode: $mode</title>\n" ;
  print HTMLTASK "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLTASK "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTMLTASK "<tr bgcolor=wheat><td><font face=$font size=5><center>Monitor Task Detail - Mode: $mode</center>\n";
  print HTMLTASK "</table>\n" ;

  print HTMLTASK "$links";

  print HTMLTASK "<hr>\n" ;

  print HTMLTASK "<p><font face=$font size=3><b>Monitor Task Detail:</font></b>\n" ;
  print HTMLTASK "<table border=0>\n" ;

  print HTMLTASK "<tr bgcolor=slate>\n" ;
  print HTMLTASK "<th><h5>Monitor Process\n" ;
  print HTMLTASK "<th><h5>Iteration<br>Number\n" ;
  print HTMLTASK "<th><h5>Iteration<br>Duration<br>(Mins.)\n" ;
  print HTMLTASK "<th><h5>Iteration<br>Completion<br>Time\n" ;
  print HTMLTASK "<th><h5>PID\n" ;
  print HTMLTASK "<th><h5>DB Server<br>Names / Classes<br>Monitored\n" ;
  print HTMLTASK "<th><h5>Task Start Time\n" ;
  print HTMLTASK "<th><h5>Number of <br>Instances<br> Monitored\n" ;
  print HTMLTASK "</tr>\n" ;

  $statement  = "
    select 
      dbamonmode, 
      pid,
      starttime_num,
      starttime_char,
      alpha,
      iter_num,
      iter_dur,
      num_instances,
      to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\') 
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    order by 
      1, 6";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $pid   = $Data[1];
    #$st_n  = $Data[2];
    $st_c  = $Data[3];
    $alpha = $Data[4];
    $i_num = $Data[5];
    $i_dur = int($Data[6] / 60);
    $num   = $Data[7];
    $ctime = $Data[8];
 
    if ($i_mode ne $last_mode && $last_mode ne "")
    {
      print HTMLTASK "<tr><td colspan=8><hr>\n";
    }

    $bg = &bg;
    if ($i_mode ne $last_mode)
    {
      print HTMLTASK "<tr $bg>
       <td><h5>$i_mode 
       <td align=right><h5>$i_num 
       <td align=right><h5>$i_dur 
       <td><h5>$ctime 
       <td><h5>$pid 
       <td><h5>$alpha 
       <td><h5>$st_c 
       <td align=right><h5>$num 
      \n";
    }
    else
    {
      print HTMLTASK "<tr $bg>
       <td><h5>$i_mode 
       <td align=right><h5>$i_num 
       <td align=right><h5>$i_dur 
       <td><h5>$ctime 
       <td><td><td><td align=right><h5>$num
      \n";

    }
    $selectcount++;
    $last_mode = $i_mode;
  }

  print HTMLTASK "</table><hr>\n" ;
  close(HTMLTASK);
}

#-----------------------------------------------------------------------------
sub makeIsolateMenu
#-----------------------------------------------------------------------------
{
  if ($isolated_urls ne "")
  {
    &msg("Creating isolated tasks menu");
    $ztext = "<table width=$table_width>
     <tr bgcolor=darkblue><td colspan=30><font face=$font size=2 color=wheat><b><center>Event Isolation</center></font></b>
     <tr bgcolor=lightgrey><td bgcolor=slate width=10%><b><font size=2>MsgID(s):</font><td><font size=2> $isolated_urls </font>
     </table><hr>\n";

    print HTMLSHORT "$ztext";
    print HTML      "$ztext";
  }
}

#-----------------------------------------------------------------------------
sub makeColorLegend
#-----------------------------------------------------------------------------
{
  &msg("Creating color legend");
  $ztext = "<table width=$table_width>
   <tr bgcolor=darkblue><td colspan=30><font face=$font size=2 color=wheat><b><center>Instance Color Legend</center></font></b>
   <tr bgcolor=lightgrey>
     <td bgcolor=lime         width=12% align=center><font size=2> <b>No Events <b></font>
     <td bgcolor=lime         width=12% align=center><font size=2> <b>&gt=1 Notation Event(s)<b></font>
     <td bgcolor=mediumpurple width=12% align=center><font size=2> <b>&gt=1 Security Event(s)<b></font>
     <td bgcolor=lightskyblue width=12% align=center><font size=2> <b>&gt=1 Performance Event(s)<b></font>
     <td bgcolor=#99cc00      width=12% align=center><font size=2> <b>&gt=1 User Event(s)<b></font>
     <td bgcolor=cyan         width=12% align=center><font size=2> <b>&gt=1 Info Event(s)<b></font>
     <td bgcolor=yellow       width=12% align=center><font size=2> <b>&gt=1 Warning Event(s)<b></font>
     <td bgcolor=red          width=12% align=center><font size=2> <b>&gt=1 Critical Event(s)<b></font>
   </table><hr>\n";

  print HTMLSHORT "$ztext";
  print HTML      "$ztext";
}

#-----------------------------------------------------------------------------
sub makeTasksShort
#-----------------------------------------------------------------------------
{
  &msg("Creating tasks section");

  print HTMLSHORT "<table width=$table_width>\n";
  print HTMLSHORT "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Monitor Task Summary</center></font></b>\n";
  print HTMLSHORT "</table>\n";
  
  print HTMLSHORT "<table width=$table_width border=0>\n" ;

  print HTMLSHORT "<tr bgcolor=slate>\n" ;
  print HTMLSHORT "<th><h5>Monitor<br>Process\n" ;
  print HTMLSHORT "<th><h5>Instances/<br>Classes<br>Being<br>Monitored\n" ;
  print HTMLSHORT "<th><h5>Last<br> Iteration <br># Completed\n" ;
  print HTMLSHORT "<th><h5>Avg. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th><h5>Min. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th><h5>Max. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th><h5>Avg. Number of <br>Instances<br>Monitored\n" ;
  print HTMLSHORT "<th><h5>Avg. Duration<br>Per Instance<br>(Mins.)\n" ;
  print HTMLSHORT "</tr>\n" ;

  $statement  = "
    select 
      dbamonmode, 
      alpha,
      max(iter_num),
      avg(iter_dur),
      min(iter_dur),
      max(iter_dur),
      avg(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num > 0
    group by
      dbamonmode,
      alpha
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg = 0;

  $total_num = 0;
  $total_min = 99999;
  $total_max = 0;
  $total_cnt = 0;
  $total_avg = 0;
  $total_avgdur = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $i_alph= $Data[1];
    $i_num = $Data[2];
    $i_dur = int($Data[3] / 60);
    $i_min = int($Data[4] / 60);
    $i_max = int($Data[5] / 60);
    $num   = sprintf("%7.1f",$Data[6]);
    $avgper= sprintf("%7.2f",$i_dur/$num);

    $bg = &bg;

    $mode_url = "<a href='/cgi-bin/dbamon_mode.pl?$i_mode'>$i_alph</a>"; 

    if    ($i_dur >= 90) { $dur_color = "pink"; } 
    elsif ($i_dur >= 60) { $dur_color = "yellow"; } 
    else                 { $dur_color = "lime"; } 

    print HTMLSHORT "
    <tr $bg>
      <td><h5>$i_mode 
      <td><h5>$mode_url
      <td align=right><h5>$i_num 
      <td align=right bgcolor=$dur_color><h5>$i_dur 
      <td align=right><h5>$i_min
      <td align=right><h5>$i_max 
      <td align=right><h5>$num 
      <td align=right><h5>$avgper 
    \n";
    $selectcount++;
    $num_instances += $num;
    
    $total_num += $i_num;
    $total_cnt += $num;
    $total_avg += $avgper;
    $total_min = $i_min if $i_min < $total_min;
    $total_max = $i_max if $i_max > $total_max;
    $total_avgdur += $i_dur;
  }

  $total_avg = $total_avg / $selectcount if $selectcount > 0;
  $total_avgdur = int($total_avgdur / $selectcount) if $selectcount > 0;

  $total_cnt = sprintf("%7.1f",$total_cnt);
  $total_avg = sprintf("%7.2f",$total_avg);

  print HTMLSHORT "<tr bgcolor=slate>\n" ;
  print HTMLSHORT "<th align=left><h5>Total:\n" ;
  print HTMLSHORT "<th ><h5>\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_num\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_avgdur\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_min\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_max\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_cnt\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_avg\n" ;

  $statement  = "
    select 
      dbamonmode, 
      max(iter_num),
      avg(iter_dur)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $color = "lime"; 

  $endmsg2  = "No tasks have reported - DBAmon is starting";
  $taskflag1 = 1;

  while (@Data = $sth->fetchrow_array)
  {
    $taskflag1 = 0;
    $endmsg2  = "Since all tasks have completed >=1 iteration, this page is complete";

    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    if ($i_num < 1) 
    {
      $endmsg1 .= "Task=$i_mode has not yet completed 1st iteration<br>";
      $endmsg2  = "This page is not yet complete";
      $color = "red";
      $taskflag2 = 1;
    }
  }

  # Experiment - if page is not complete, then die
  if ($taskflag1 || $taskflag2)  
  {
    &msg("Page not complete - Exiting - taskflag1=$taskflag1 taskflag2=$taskflag");
    exit 0;
  }

  print HTMLSHORT "<tr><td colspan=8 bgcolor=$color align=center><h5>$endmsg1 $endmsg2 \n";
  ##print HTMLSHORT "</form>\n" ;
  print HTMLSHORT "</table>\n" ;
  print HTMLSHORT "<ul><li><h5><a href='$task_detail_url'>Monitor Task Details</a></ul>\n" ;
  print HTMLSHORT "<hr>\n" ;
}

#-----------------------------------------------------------------------------
sub makeTasks
#-----------------------------------------------------------------------------
{
  &msg("Creating tasks section");

  print HTML "<table width=$table_width>\n";
  print HTML "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Monitor Task Summary</center></font></b>\n";
  print HTML "</table>\n";
  
  print HTML "<table border=0 width=$table_width>\n" ;

  print HTML "<tr bgcolor=slate>\n" ;
  print HTML "<th><h5>Monitor Process\n" ;
  print HTML "<th><h5>Instances/<br>Classes<br>Being<br>Monitored\n" ;
  print HTML "<th><h5>Last<br> Iteration <br># Completed\n" ;
  print HTML "<th><h5>Avg. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th><h5>Min. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th><h5>Max. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th><h5>Avg. Number of <br>Instances<br>Monitored\n" ;
  print HTML "<th><h5>Avg. Duration<br>Per Instance<br>(Mins.)\n" ;
  print HTML "</tr>\n" ;

  $statement  = "
    select 
      dbamonmode, 
      alpha,
      max(iter_num),
      avg(iter_dur),
      min(iter_dur),
      max(iter_dur),
      avg(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num > 0
    group by
      dbamonmode,
      alpha
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $i_alph= $Data[1];
    $i_num = $Data[2];
    $i_dur = int($Data[3] / 60);
    $i_min = int($Data[4] / 60);
    $i_max = int($Data[5] / 60);
    $num   = sprintf("%7.1f",$Data[6]);
    $avgper= sprintf("%7.2f",$i_dur/$num);

    $bg = &bg;

    $mode_url = "<a href='/cgi-bin/dbamon_mode.pl?$i_mode'>$i_alph</a>"; 

    print HTML "
      <tr $bg>
        <td><h5>$i_mode 
        <td><h5>$mode_url
        <td align=right><h5>$i_num 
        <td align=right><h5>$i_dur 
        <td align=right><h5>$i_min
        <td align=right><h5>$i_max 
        <td align=right><h5>$num 
        <td align=right><h5>$avgper 
    \n";

    $selectcount++;
    $num_instances += $num;
  }

  $statement  = "
    select 
      dbamonmode, 
      max(iter_num),
      avg(iter_dur)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $color = "lime"; 

  $endmsg2  = "No tasks have reported - DBAmon is starting";
  $taskflag1 = 1;

  while (@Data = $sth->fetchrow_array)
  {
    $taskflag1 = 0;
    $endmsg2  = "Since all tasks have completed >=1 iteration, this page is complete";

    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    if ($i_num < 1) 
    {
      $endmsg1 .= "Task=$i_mode has not yet completed 1st iteration<br>";
      $endmsg2  = "This page is not yet complete";
      $color = "red";
      $taskflag2 = 1;
    }
  }

  # Experiment - if page is not complete, then die
  if ($taskflag1 || $taskflag2)  
  {
    &msg("Page not complete - Killing myself - taskflag1=$taskflag1 taskflag2=$taskflag");
    exit 1;
  }

  print HTML "<tr><td colspan=8 bgcolor=$color><h5>$endmsg1 $endmsg2 \n";
  ##print HTML "</form>\n" ;
  print HTML "</table>\n" ;
  print HTML "<ul><li><h5><a href='$task_detail_url'>Monitor Task Details</a></ul>\n" ;
  print HTML "<hr>\n" ;
}

#-----------------------------------------------------------------------------
sub checkTasks
#-----------------------------------------------------------------------------
{
  # See if all tasks have completed the first iteration - if not, then die

  $statement  = "
    select 
      dbamonmode, 
      max(iter_num),
      avg(iter_dur)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $tasks_starting = 0;
  $tasks_count    = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $tasks_count++;
    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    ##print "task=$i_mode maxiter=$i_num\n";

    if ($i_num < 1) 
    {
      $taskflag3 = 1;
      $tasks_starting++;
    }
  }

  if ($taskflag3)  
  {
    ## system("echo '<font color=red>Starting</font>' > /opt/dbamon/htm/status_$modelc.txt");  
    &error("DBAmon $tasks_starting/$tasks_count Tasks Starting - Killing myself - taskflag3=$taskflag3 tasks_count=$tasks_count tasks_starting=$tasks_starting",2);
  }

  &msg("All mode=$modelc tasks appear to have completed iteration #1");
}

#-----------------------------------------------------------------------------
sub reportMenu
#-----------------------------------------------------------------------------
{
  &msg("Creating report menu");

  # make sure dir exists
  if (! -x "/opt/dbamon/htm/reports/")
  {
    system("mkdir /opt/dbamon/htm/reports/");
  }

  $rpt_dbtime = 0;

  foreach (@instance_list)
  {
    s/ //g;
    $inst = $_;
    $instuc = uc $inst;
    ##&msg("Found instance=$inst");

    $zsrvr = (split(":",$inst)) [0];
    $zinst = (split(":",$inst)) [1];

    $b4 = time;

    $statement = "select dbms, dbmsver from dbamon.instances 
                  where system like '$zsrvr%' 
                    and instance = '$zinst' 
                    and dbamonmode like '%${modelc}%'";
    $sth = $dbh->prepare($statement) ||
	    &error('Select_$what');
    $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
    $selectcount = 0;
    $dbms = "?";
    $dver = "?";
    while (@Data = $sth->fetchrow_array)
    {
      $selectcount++;
      ($dbms = $Data[0]) =~ s/ //g;
      ($dver = $Data[1]) =~ s/ //g;
    }

    $rpt_dbtime += (time - $b4);

    $dver = substr($dver,1) if $dver =~ /^0/;

    $ver1 = substr($dver,0,1);

    if    ($dbms eq "Oracle" && $ver1 ge "8") { $incfile = "inc1"; }
    elsif ($dbms eq "Oracle" && $ver1 lt "8") { $incfile = "inc2"; }
    else                                      { $incfile = "inc3"; }

    $zinstuc = uc $zinst;

    &msg("dbms=$dbms dver=$dver ver1=$ver1 incfile=$incfile zsrvr=$zsrvr zinst=$zinst");

    # build menu 
    $html_template = `cat /opt/dbamon/lib/dbamon_ora_sumread.$incfile.html`;
    $html_template =~ s/INSTANUC/$instuc/g;
    $html_template =~ s/INSTANCE/$inst/g;
    $html_template =~ s/MODE/$modelc/g;
    $html_template =~ s/SERVER/$zsrvr/g;
    $html_template =~ s/DBNAME/$zinst/g;
    $html_template =~ s/DBNAUC/$zinstuc/g;

    $file = "/opt/dbamon/htm/reports/$inst.html";
    open(RPTINST, ">/opt/dbamon/htm/reports/$inst.html") || &error("Cannot open output $file - $!");
    print RPTINST "$html_template";
    close(RPTINST); 
    $menucount++;
  }
  &msg("Created $menucount report menus - rpt_dbtime=$rpt_dbtime");
}

#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
    chop($dbc_count = `ll /opt/dbamon/adm/instances_test/*.dbc | wc -l`);
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
    chop($dbc_count = `ll /opt/dbamon/adm/instances/*.dbc | wc -l`);
  }
  &msg("DBC File Count: $dbc_count");

  &msg("rm'ing old .new files - Usage error message is OK");
  system("find /opt/dbamon/htm/tmp/*.new -mtime +1 | xargs rm");

  # Read ID1_Breakout: parm
  chop($id1_breakout = `grep 'ID1_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id1_breakout=$id1_breakout  ");

  # Read ID2_Breakout: parm
  chop($id2_breakout = `grep 'ID2_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id2_breakout=$id2_breakout  ");

  # Read ID3_Breakout: parm
  chop($id3_breakout = `grep 'ID3_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id3_breakout=$id3_breakout  ");

  # Read ID4_Breakout: parm
  chop($id4_breakout = `grep 'ID4_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id4_breakout=$id4_breakout  ");

  # Read ID5_Breakout: parm
  chop($id5_breakout = `grep 'ID5_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id5_breakout=$id5_breakout  ");

  # Read ID6_Breakout: parm
  chop($id6_breakout = `grep 'ID6_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id6_breakout=$id6_breakout  ");

  # Read ID7_Breakout: parm
  chop($id7_breakout = `grep 'ID7_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id7_breakout=$id7_breakout  ");

  # Read ID8_Breakout: parm
  chop($id8_breakout = `grep 'ID8_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id8_breakout=$id8_breakout  ");

  # Read ID9_Breakout: parm
  chop($id9_breakout = `grep 'ID9_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id9_breakout=$id9_breakout  ");

  # Read ID10_Breakout: parm
  chop($id10_breakout = `grep 'ID10_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id10_breakout=$id10_breakout  ");

  # Read Loc_Breakout: parm
  chop($loc_breakout = `grep 'Loc_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("loc_breakout=$loc_breakout  ");
  
  # Read Loc_Breakout: parm
  chop($events_isolate = `grep 'WWW_Event_Isolate:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("events_isolate=$events_isolate  ");

  #---- Read IDx_Label parms
  $id1_label = &dbamonrcLabel("1"); 
  $id2_label = &dbamonrcLabel("2"); 
  $id3_label = &dbamonrcLabel("3"); 
  $id4_label = &dbamonrcLabel("4"); 
  $id5_label = &dbamonrcLabel("5"); 
  $id6_label = &dbamonrcLabel("6"); 
  $id7_label = &dbamonrcLabel("7"); 
  $id8_label = &dbamonrcLabel("8"); 
  $id9_label = &dbamonrcLabel("9"); 
  $id10_label = &dbamonrcLabel("10"); 
  msg("id3_label=$id3_label ");

  # Read WWW_Check:
  chop($font = `grep 'WWW_Font:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  if ($font =~ /%/)
  {
    $font =~ s/%/ /g;
    $font = "'$font'";
  }
  msg("font=$font  ");
  
  chop($verrel        = `cat /opt/dbamon/bin/verrel`);
  chop($startdate     = `cat /opt/dbamon/adm/startdate_${modelc}.txt`);

  ##msg("html_sys_path=$html_sys_path  ");

  chop($hostname = `hostname`);
  chop($date = `date`);

  #$html_sys_path_new = "${html_sys_path}.$$.new";
  $html_sys_path_new = "/opt/dbamon/htm/tmp/syspath_${modelc}_$$.html.new";
  msg("Opening output HTML file: $html_sys_path_new");
  system("mkdir /opt/dbamon/htm/tmp > /dev/null 2>&1");
  open(HTML, ">$html_sys_path_new") || &error("Cannot open output $html_sys_path_new - $!");

  $task_detail_file = "/opt/dbamon/htm/task_detail_${modelc}.html";
  $task_detail_url  = "task_detail_${modelc}.html";

  if ($modelc eq "test") { $detpath = "instance_detail_test.html"; }
  else                   { $detpath = "instance_detail.html"; }

  $links_include = `cat /opt/dbamon/lib/trans_links.txt`;

  $links = "
    <table width=$table_width>

    $links_include

    <tr bgcolor=lightgrey align=center>
      <td colspan=30><font face=$font size=-1><i>Page generated by DBAmon version
        <a HREF='http://dbamon.com/misc/change_history.shtml'><b>$verrel</b></a> mode=$mode
        on Master=$hostname at $date<br>DBAmon started $startdate</i></font>
    </table>
  ";
}

#------------------------------------------------------------------------------
sub dbamonrcLabel
#------------------------------------------------------------------------------
{
  my $thisid = $_[0];
  #---- Read IDx_Label parms
  chop($dl_label_raw = `grep 'ID${thisid}_Label:' $rcfile | grep -v '^#'`);
  my @zwords = split(" ",$dl_label_raw);
  my $dl_label = substr($dl_label_raw,index($dl_label_raw,$zwords[1])); 
  msg("thisid=$thisid dl_label=$dl_label");
  return $dl_label;
}
  
#------------------------------------------------------------------------------
sub missingAlpha
#------------------------------------------------------------------------------
{
  foreach $letter (A..Z)
  {
    if (! $created_alpha{$letter})
    {
      &msg("Creating null alpha page: $letter");
      open(HTMLALPHA, ">/opt/dbamon/htm/alpha_$modelc/$letter.html") || &error("Cannot open output /opt/dbamon/htm/alpha_$modelc/$letter.html - $!");
      print HTMLALPHA "<title>DBAmon Instance Summary - ALPHA: $thisid1 - Mode: $mode</title>\n" ;
      print HTMLALPHA "<meta http-equiv=Refresh content=36000><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
      print HTMLALPHA "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
      print HTMLALPHA "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
      print HTMLALPHA "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For '$letter' Servers</center>\n";
      print HTMLALPHA "</table>\n" ;
      print HTMLALPHA "$links";
      print HTMLALPHA "<hr>\n" ;
      print HTMLALPHA "<p><font face=$font size=3><b>Instance Detail - '$letter' - NO Instances</font></b>\n" ;
      close HTMLALPHA; 
    }
  }
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("=============================================================================================");
&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 - version=$version");

if ($mode eq "PROD")
{
  system("         ps -ef | grep $P | grep -v grep");
  chop($numproc = `ps -ef | grep $P | grep -v grep | wc -l`);
  &msg("Number of ${P}'s for mode=$mode running: $numproc");
  if ($numproc > 2)
  {
    &msg("There is another instance of $P running - numproc=$numproc - killing myself");
    exit 2; 
  }
}

&connectDB;
&init;

&checkTasks;

&makeTitle; 
&makeScoreboard; 

&makeDetailShort; 
&makeDetail; 

&makeTasks; 
&makeFoot; 

&makeSev;

foreach $dbms (@dbmslist)
{
  ##print "dbms=$dbms \n";
  &makeDetailDBMS($dbms); 
}

if ($id1_breakout eq "Y")
{
  foreach $id1 (@id1list)
  {
    ##print "id1=$id1 \n";
    &makeDetailID1($id1); 
  }
}

if ($id2_breakout eq "Y")
{
  foreach $id2 (@id2list)
  {
    ##print "id2=$id2 \n";
    &makeDetailID2($id2); 
  }
}

if ($id3_breakout eq "Y")
{
  foreach $id3 (@id3list)
  {
    ##print "id3=$id3 \n";
    &makeDetailID3($id3); 
  }
}

if ($id4_breakout eq "Y")
{
  foreach $id4 (@id4list)
  {
    ##print "id4=$id4 \n";
    &makeDetailID4($id4); 
  }
}

if ($id5_breakout eq "Y")
{
  foreach $id5 (@id5list)
  {
    ##print "id5=$id5 \n";
    &makeDetailID5($id5); 
  }
}

if ($id6_breakout eq "Y")
{
  foreach $id6 (@id6list)
  {
    ##print "id6=$id6 \n";
    &makeDetailID6($id6); 
  }
}

if ($id7_breakout eq "Y")
{
  foreach $id7 (@id7list)
  {
    ##print "id7=$id7 \n";
    &makeDetailID7($id7); 
  }
}

if ($id8_breakout eq "Y")
{
  foreach $id8 (@id8list)
  {
    ##print "id8=$id8 \n";
    &makeDetailID8($id8); 
  }
}

if ($id9_breakout eq "Y")
{
  foreach $id9 (@id9list)
  {
    ##print "id9=$id9 \n";
    &makeDetailID9($id9); 
  }
}

if ($id10_breakout eq "Y")
{
  foreach $id10 (@id10list)
  {
    ##print "id10=$id10 \n";
    &makeDetailID10($id10); 
  }
}

if ($loc_breakout eq "Y")
{
  foreach $loc (@loclist)
  {
    ##print "loc=$loc \n";
    &makeDetailLOC($loc); 
  }
}

# Make menu of isolated events
&makeColorLegend;

# Make menu of isolated events
&makeIsolateMenu;

# Create dummy page(s) for missing alphas
&missingAlpha;

&msg("Closing HTML filehandle");
close(HTML);
close(HTMLSHORT);

&msg("Renaming $html_sys_path_new to $html_sys_path");
$rc = system("mv $html_sys_path_new $html_sys_path"); 
if ($rc != 0) 
{
  &error("Error renaming $html_sys_path_new to $html_sys_path");
}

&msg("Renaming $shortpath to $shortpath_perm");
$rc = system("mv $shortpath $shortpath_perm"); 
if ($rc != 0) 
{
  &error("Error renaming $shortpath to $shortpath_perm");
}

# Just in case
system("rm $html_sys_path_new > /dev/null 2>&1"); 

&msg("Invoking dbamon_uptime_summarize");
chop($dow = `date +%a`);
system("dbamon_uptime_summarize >> /opt/dbamon/log/downtime/dbamon_uptime_summarize_${dow}.log 2>&1");

&msg("Invoking dbamon_qc");
system("dbamon_qc.pl > /opt/dbamon/log/dbamon_qc.log 2>&1");

#---- BB 06Dec07 Moved this to cron
#&msg("Invoking dbamon_ora_util eventCleanup");
#system("echo 'dbamon_ora_util prod eventCleanup >> /opt/dbamon/log/dbamon_eventCleanup.log 2>&1' | at now");

&msg("Done");
chop($date = `date +%Y/%m/%d-%H:%M:%S`);
system("echo '$date' > /opt/dbamon/htm/asof_$modelc.txt");
chop($size = `ls -l /opt/dbamon/htm/$detpath | awk '{ print \$5 }'`);
system("echo '$size' > /opt/dbamon/htm/sizeof_$modelc.txt");

# Copy email data to EMAIL table
&emailCopy;

# Create report menus
&reportMenu;

$num_instances /= 2;
system("echo '$date - $mode - $num_instances' >> $log");
##system("echo '<font color=lime>Running as of $date - $task_count Tasks Running</font>' > /opt/dbamon/htm/status_$modelc.txt");  

#---- Log the instance count and health setting to a file in /opt/dbamon/dat
&logToFile;

exit 0;
